#include <dos.h>
#include <stdio.h>

/*

*/
#include "i2c.c"

#define DEVICE_EEPROM 0xA0

/*

*/
get_pci_busDeviceNo()
{
    union REGS r1;
    int   idx;

        r1.w.ax = 0xb102;
        r1.w.cx = 0x036E; // BT878
        r1.w.dx = 0x109E; // Conexant
        r1.w.si = 0;
        int386(0x1a, &r1, &r1);

        if (r1.w.ax & 0xff00)
        {
        }
        else return(r1.w.bx & 0xffff);

    printf("Cannot find BT878 device.\n");
    return(-1);
}

PCI_write_config_word(short busDeviceNo, int reg, int value)
{
    union REGS r1;

    reg = reg*4;

    r1.w.ax = 0xb10c;
    r1.w.bx = busDeviceNo;
    r1.w.di = reg;
    r1.w.cx = value & 0xffff;
    int386(0x1a, &r1, &r1);
}

read_PCI_config_reg(short busDeviceNo,int reg)
{
    union REGS r1;
    unsigned config_reg;

    reg = reg*4;

    r1.w.ax = 0xb109;               // Read Config Word
    r1.w.bx = busDeviceNo;
    r1.w.di = reg;          // address lsw.
    int386(0x1a, &r1, &r1);

    if (r1.w.ax & 0xff00) {
        printf("Reading PCI config lsw failed\n");
        return(-1);
    }
    config_reg = r1.w.cx;
    r1.w.ax = 0xb109;               // Read Config Word
    r1.w.bx = busDeviceNo;
    r1.w.di = reg+2;                // address msw.
    int386(0x1a, &r1, &r1);

    if (r1.w.ax & 0xff00) {
        printf("Reading PCI config msw failed\n");
        return(-1);
    }
    config_reg = (r1.w.cx << 16) | (config_reg & 0xffff);
    return(config_reg);
}


/*


*/

void* mmap(void* addr, int len, int prot, int flags, int fd, int off)
{
  union REGS r1;

  /* Map Physical Address */
  r1.w.ax = 0x0800;
  r1.w.bx = ((int)addr >> 16) & 0xFFFF;
  r1.w.cx = ((int)addr >>  0) & 0xFFF0;
  r1.w.si = (len >> 16) & 0xffff;
  r1.w.di = (len >>  0) & 0xffff;
  int386(0x31, &r1, &r1);
  if (r1.x.cflag)  {
    /* errno = EINVAL; */
    return((void*)-1);
    printf("mapping physical address failed\n");
  }
  addr = (void*)((r1.w.bx << 16) + r1.w.cx);
  return(addr);
}

mapBT878() {
    short busDeviceNo;
    void * BT878_BaseAddr;

    // Get PCI Bus number and device number.
    busDeviceNo = get_pci_busDeviceNo();
    if (busDeviceNo == -1) {
        return(-1);
    }

#if 0
    // Make sure NV PCI memory access enabled.
    PCI_write_config_word( busDeviceNo, 1,
        read_PCI_config_reg( busDeviceNo, 1 ) | 0x0002 // Memory Access Enabled.
            );
#endif

    // Get the PCI device memory map physical starting address. 4K size
    BT878_BaseAddr = mmap((void*)read_PCI_config_reg(busDeviceNo,4),0x00001000,0,0,0,0);

    if (BT878_BaseAddr == (int *)-1)  {
        printf("Cannot mmmap(BT878)\n");
        return(-1);
    }
    BT878_I2CAddr = (int *)((long)BT878_BaseAddr+0x110);
    return(0);
} /* end mapBT878V */

int main(int argc,char *argv[])
{
        int Data,Status;
        int idx,eeprom_data,idx_max;


    if (mapBT878()==-1) return 1;

    Data = 0xFF;
    Status = I2C_ReadByte(DEVICE_EEPROM,(char *)&Data);
    if (!Status)
    {
        printf("EEPROM not found.\n");
        return 1;
    }
    if (argc == 3)
    {
        sscanf(argv[1],"%d",&idx_max);
        sscanf(argv[2],"%x",&eeprom_data);
        for (idx=0;idx<idx_max;idx++)
        {
           Status = I2C_Write(DEVICE_EEPROM,idx,eeprom_data);
           if (!Status) return 1;
           printf(".");
           if ( (idx&0x0F) == 0x0F) printf("\n");
        }
    }
    else if (argc == 2)
    {
        sscanf(argv[1],"%x",&eeprom_data);
        for (idx=0;idx<256;idx++)
        {
           Status = I2C_Write(DEVICE_EEPROM,idx,eeprom_data);
           if (!Status) return 1;
           printf(".");
           if ( (idx&0x0F) == 0x0F) printf("\n");
        }
    }
    else
    {
        for (idx=0;idx<256;idx++)
        {
           Status = I2C_Write(DEVICE_EEPROM,idx,0xFF);
           if (!Status) return 1;
           printf(".");
           if ( (idx&0x0F) == 0x0F) printf("\n");
        }
    }
    return 0;
}
