#include <dos.h>
#include <stdio.h>

/*

*/
#include "i2c.c"

/*

*/
get_pci_busDeviceNo()
{
    union REGS r1;
    int   idx;

        r1.w.ax = 0xb102;
        r1.w.cx = 0x036E; // BT878
        r1.w.dx = 0x109E; // Conexant
        r1.w.si = 0;
        int386(0x1a, &r1, &r1);

        if (r1.w.ax & 0xff00)
        {
        }
        else return(r1.w.bx & 0xffff);

    printf("Cannot find BT878 device.\n");
    return(-1);
}

PCI_write_config_word(short busDeviceNo, int reg, int value)
{
    union REGS r1;

    reg = reg*4;

    r1.w.ax = 0xb10c;
    r1.w.bx = busDeviceNo;
    r1.w.di = reg;
    r1.w.cx = value & 0xffff;
    int386(0x1a, &r1, &r1);
}

read_PCI_config_reg(short busDeviceNo,int reg)
{
    union REGS r1;
    unsigned config_reg;

    reg = reg*4;

    r1.w.ax = 0xb109;               // Read Config Word
    r1.w.bx = busDeviceNo;
    r1.w.di = reg;          // address lsw.
    int386(0x1a, &r1, &r1);

    if (r1.w.ax & 0xff00) {
        printf("Reading PCI config lsw failed\n");
        return(-1);
    }
    config_reg = r1.w.cx;
    r1.w.ax = 0xb109;               // Read Config Word
    r1.w.bx = busDeviceNo;
    r1.w.di = reg+2;                // address msw.
    int386(0x1a, &r1, &r1);

    if (r1.w.ax & 0xff00) {
        printf("Reading PCI config msw failed\n");
        return(-1);
    }
    config_reg = (r1.w.cx << 16) | (config_reg & 0xffff);
    return(config_reg);
}


/*


*/
#define DEVICE_EEPROM 0xA0

void* mmap(void* addr, int len, int prot, int flags, int fd, int off)
{
  union REGS r1;

  /* Map Physical Address */
  r1.w.ax = 0x0800;
  r1.w.bx = ((int)addr >> 16) & 0xFFFF;
  r1.w.cx = ((int)addr >>  0) & 0xFFF0;
  r1.w.si = (len >> 16) & 0xffff;
  r1.w.di = (len >>  0) & 0xffff;
  int386(0x31, &r1, &r1);
  if (r1.x.cflag)  {
    /* errno = EINVAL; */
    return((void*)-1);
    printf("mapping physical address failed\n");
  }
  addr = (void*)((r1.w.bx << 16) + r1.w.cx);
  return(addr);
}

mapBT878() {
    short busDeviceNo;
    void * BT878_BaseAddr;

    // Get PCI Bus number and device number.
    busDeviceNo = get_pci_busDeviceNo();
    if (busDeviceNo == -1) {
        return(-1);
    }

#if 0
    // Make sure NV PCI memory access enabled.
    PCI_write_config_word( busDeviceNo, 1,
        read_PCI_config_reg( busDeviceNo, 1 ) | 0x0002 // Memory Access Enabled.
            );
#endif

    // Get the PCI device memory map physical starting address. 4K size
    BT878_BaseAddr = mmap((void*)read_PCI_config_reg(busDeviceNo,4),0x00001000,0,0,0,0);

    if (BT878_BaseAddr == (int *)-1)  {
        printf("Cannot mmmap(BT878)\n");
        return(-1);
    }
    BT878_I2CAddr = (int *)((long)BT878_BaseAddr+0x110);
    return(0);
} /* end mapBT878V */

int main(int argc,char *argv[])
{
    unsigned int Status,Data,idx,found=0;

    if (mapBT878()==-1) return 1;

    if (argc == 3)
    {
        int DevID,SubAddr,Data;

        DevID=SubAddr=Data=0x00;

        sscanf(argv[1],"%x",&DevID);
        sscanf(argv[2],"%x",&SubAddr);
        Status = I2C_Read(DevID,SubAddr,(char *)&Data,1);
        if (Status)
        {
            printf("I2C read (%x,%x,%x).\n",DevID,SubAddr,Data);
            return 0;
        }
        else
        {
            printf("***** ERROR ***** I2C read (%x,%x) failed.\n",DevID,SubAddr);
            return 1;
        }
    }
    if (argc == 4)
    {
        int DevID,SubAddr,Data;

        DevID=SubAddr=Data=0xFF;

        sscanf(argv[1],"%x",&DevID);
        sscanf(argv[2],"%x",&SubAddr);
        sscanf(argv[3],"%x",&Data);
        Status = I2C_Write(DevID,SubAddr,Data);
        if (!Status)
        {
            printf("***** ERROR ***** I2C write (%x,%x,%x) failed.\n",DevID,SubAddr,Data);
            return 1;
        }
        return 0;
    }

    for (idx=0x0;idx<0xFF;idx+=2)
    {
        Data = 0xFF;
        Status = I2C_ReadByte(idx,(char *)&Data);
        if (Status)
        {
           printf("I2C Device %2.2Xh found (%2.2Xh).\n",idx,Data);
           found = 1;
        }
        else        printf("I2C Device %2.2Xh\015",idx);
    }
    printf("                                                 \015");
    if (!found)
    {
        printf("No I2C device found.\n");
        return 1;
    }
    return 0;
}
